package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.scheduling.management.SchCollectorConfig;
import com.docus.server.infrastructure.dao.ISchCollectorConfigDao;
import com.docus.server.infrastructure.mapper.SchCollectorConfigMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * 采集器配置 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-07-15
 */
@Repository
public class SchCollectorConfigDaoImpl extends BaseDaoImpl<SchCollectorConfigMapper, SchCollectorConfig> implements ISchCollectorConfigDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public SchCollectorConfig findById(String id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param schCollectorConfig 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(SchCollectorConfig schCollectorConfig) {
        return super.save(schCollectorConfig);
    }

    /**
     * 编辑
     *
     * @param schCollectorConfig 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(SchCollectorConfig schCollectorConfig) {
        return super.updateById(schCollectorConfig);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<SchCollectorConfig> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<SchCollectorConfig> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchDTO.getBeginTime() != null) {
            query.ge(SchCollectorConfig::getCreateTime, searchDTO.getBeginTime());
        }
        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(SchCollectorConfig::getCreateTime, endTime);
        }

        if (searchDTO.getParams("collectorId") != null && searchDTO.getParams("collectorId") != "") {
            query.eq(SchCollectorConfig::getCollectorId, searchDTO.getParams("collectorId"));
        }

        if (searchDTO.getParams("configType") != null && searchDTO.getParams("configType") != "") {
            query.eq(SchCollectorConfig::getConfigType, searchDTO.getParams("configType"));
        }

        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(SchCollectorConfig::getCreateTime, endTime);
        }

        //默认createTime倒序排序
        query.orderByDesc(SchCollectorConfig::getCreateTime);
        List<SchCollectorConfig> list = super.find(query);
        return new PageResult<>(list);
    }

}
